#line 1 "C:/Users/uemin/Desktop/mikroC/XY Joystick Modulu ile Servo Motor Kontrolu/main.c"

sbit LED at LATA4_bit;
sbit SERVO at LATB0_bit;

unsigned int adc=0;
unsigned int degree;


void vdelay_10us(unsigned int time){
 while(time){
 delay_us(10);
 time--;
 }
}


long map(long x, long in_min, long in_max, long out_min, long out_max) {
 return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

void setServoDegree(unsigned int deg){
 unsigned int TON;

 TON=map(deg, 0, 180, 50, 240);


 SERVO=1;
 vdelay_10us(TON);
 SERVO=0;
 vdelay_10us(2000-TON);
}

void main() {

 TRISA=0b00000010;
 TRISB=0b00000000;
 TRISC=0b00000000;
 TRISD=0b00000000;
 TRISE=0b00000000;


 ANSELA=0b00000010;
 ANSELB=0b00000000;
 ANSELC=0b00000000;
 ANSELD=0b00000000;
 ANSELE=0b00000000;


 LATA=0x00;
 LATB=0x00;
 LATC=0x00;
 LATD=0x00;
 LATE=0x00;


 while(1){
 adc=ADC_Read(1);
 degree=map(adc, 0, 1023, 0, 180);

 setServoDegree(degree);
 }
}
